#include <R.h>  //Used for some debuggying via R
#include <Rdefines.h> // CN addition, from R-C inteface document,
#include <Rmath.h>
#include <Rinternals.h> // RK addition
#include <R_ext/RS.h>	// RK addition
#include <R_ext/Lapack.h> // RK addition
#include <R_ext/BLAS.h> // RK addition
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>

//C versions for the CP calulation via FMCI 
//Mainly concerns the double for loop for when we compute the probability of each chain (representing the run/ CP) being in each state

void CP_FMCI_RowUpdate(double *psi, double *psim1, double *Zvec, int *sizeZ, int *maxCP, double *newpsi){
//C based version to perform the row updating part of the CP via FMCI approach
	//psi = transition probability mat of chain being in each state for a specific time
		//uth chain tracks the uth run/pattern/CP
	//psi = psimat at some time t
	//psim1 = psi at time t-1
	//Zvec = Z vector of elements for the transition, identity matrix, upsilon part of the updating algorithm
	//sizeZ = number of states in the augmented SS. Length of psi vec, ncol of Mmat, ncol=nrow of Upsilon,at
	// maxCP= max number of CP considered (implicit assumption), nrow 

//Create some of the matrices for my own sanity

int zstar=*sizeZ ;
//The psi matrices (prob of chains being in each state
int entry=0;
double Psi[*maxCP][*sizeZ], Psim1[*maxCP][*sizeZ], newPsi[*maxCP][*sizeZ];
for(int i=0; i<*maxCP; i++){ //To create a matrix given a vector of the elements
for(int j=0; j<*sizeZ; j++){
	Psi[i][j] = *(psi+entry);	//Recreate the Psi matrices of interest
	newPsi[i][j] = *(psi+entry);
	Psim1[i][j] = *(psim1 +entry);
	entry++; //Move the entry by one
}
}	
 
//Z matrix
entry=0;
double Zmat[*sizeZ][*sizeZ];	
for(int i=0; i<*sizeZ; i++){
for(int j=0; j<*sizeZ; j++){
	Zmat[i][j] = *(Zvec+entry); //Placement of the transition probability
	entry++;
}
}

for(int chain=1; chain<*maxCP; chain++){
	//Consider updating the rows for chain 2,.... maxCP

//Creating the additional updating component of 
double add_comp_vec[zstar];
for(int entry=0; entry<zstar; entry++){
	add_comp_vec[entry]=0 ;//To start from a fresh for each chain
}
 
for(int z2=0; z2<*sizeZ; z2++){
for(int z1=0; z1<*sizeZ; z1++){
	add_comp_vec[z2] += Psim1[chain-1][z1] * Zmat[z1][z2];
	}
	}

//The actual row updating formula
for(int state=0; state<*sizeZ; state++){
newPsi[chain][state] = Psi[chain][state] + add_comp_vec[state];
}
}

entry=0;
for(int chain=0; chain<*maxCP; chain++){
for(int state=0; state<*sizeZ; state++){
	*(newpsi+entry) = newPsi[chain][state]; //So I get the actual output that I need
	entry++;
	}
	}

}
