#Row updating part of Psi matrix for CP via FMCI approach

Psi.Row.update_Sparse<-function(Psi.mat, Psim1.mat, TP.mat, Upsilon.mat){
	#Function to perform the row updating part of the CP calculations via FMCI
	#Psi.mat = psi matrix (probability of each chain being in each state) at time t
	#Psim1 = psi matrix for time t-1
	#TP.mat = transition matrix for time t
	#Upsilon.mat = upsilon matrix which connects absorption to continuation states

dyn.load("CP_via_FMCI_cal_Cver.so")

z.star<-nrow(TP.mat) #Size of the underlying statespace
Z.mat<-(TP.mat - Matrix(diag(z.star))) %*% Upsilon.mat

max.noCP<-nrow(Psi.mat) #Maximum number of CP assumed

info<-.C("CP_FMCI_RowUpdate", as.double(t(Psi.mat)), as.double(t(Psim1.mat)), as.double(t(Z.mat)), as.integer(z.star), as.integer(max.noCP), "UpdPsi"=double(length(Psi.mat)))
Updpsi.vec<-as.vector(info[["UpdPsi"]])
#browser()
UpdPsi.mat<-matrix(Updpsi.vec, nrow=max.noCP, ncol=z.star, byrow=T) #Reconstruct the Psi matrix for future use
Matrix(UpdPsi.mat)
}
