#include <R.h>  //Used for some debuggying via R
#include <Rdefines.h> // CN addition, from R-C inteface document,
#include <Rmath.h>
#include <Rinternals.h> // RK addition
#include <R_ext/RS.h>	// RK addition
#include <R_ext/Lapack.h> // RK addition
#include <R_ext/BLAS.h> // RK addition
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>

void Dep_Wav_Per_LL(double *data_vec, int *ndata, double *TPvec, double *Sigma_vec, double *init_vec, double *lilo, double *scaling, int *Xsize, int *no_J, double *alt_sign_vec){
//To compute the log-likelihood of a Multi Wavelet Scale Processes with cross correlation
	//data= the data matrix in vector form
	//ndata =length of the time points in the data
	//TPvev =transition probability matrix in vector form
	//Sigma_vec= The sigma mat array information in vector form
	//init_vec = the initisation vector of the underlying MC
	//lilo = log-likelihood that we want as the output
	//scaling = vector containing scaling constants from which the log-lik is computed from
	//Xsize= The size of the underlying state space
 //no_J = number of scale processes under consideration 

//Objects that I need to help me
int iter; //Iterations used in the for loop
//double scaling[*ndata];  // Scaling vector storage 

int nr=*Xsize; //Size of the underlying statespace, the same as Xsize. Just so I don't get confused...
 
double old_init_vec[nr]; //Storage for old 
	

//Data matrix construction
double datamat[*no_J][*ndata];
for(int level=0; level<*no_J; level++){
for(int time=0; time<*ndata; time++){
        datamat[level][time] =  data_vec[(level*(*ndata))+time];
        }
        }

//TP mat construction
double TPmat[nr][nr]; 	
for(int i=0; i<nr; i++){ //To create a matrix given a vector of the elements
for(int j=0; j<nr; j++){
	TPmat[i][j] = TPvec[(nr*i)+j];
}
}

//Sigma D array construction
//double Sigma_mat_array[*no_J][*no_J][nr];
//for(int state=0; state<nr; state++){
//for(int i=0; i<*no_J; i++){
//for(int j=0; j<*no_J; j++){
//       Sigma_mat_array[i][j][state] = *(Sigma_vec+((*no_J*i)+j)*nr);
//      }
//}
//}
//printf("B Sigma Mat R1 %f %f \n:",  (float) bSigma_mat[0][0], (float) bSigma_mat[0][1]);
//printf("B Sigma Mat R2 %f %f \n:",  (float) bSigma_mat[1][0], (float) bSigma_mat[1][1]);

int no_sign_combns = R_pow_di(2, *no_J);
//printf("No Alt Signs Combins: %i \n", no_sign_combns);

//Alt Sign matrix construction
int Alt_Sign_mat_vec[no_sign_combns * *no_J];
for(int entry=0; entry<(no_sign_combns**no_J); entry++){

Alt_Sign_mat_vec[entry] = *(alt_sign_vec+entry); //Copy of the Alt_Sign Vector
		//printf("Alt Sign: %d \n", Alt_Sign_mat_vec[entry]);
      }


void MVN_Sq_density(); ///The emission density function

//The actual forward equations recursion
for(iter=0; iter<*ndata; iter++) {

//Current data at the time point
double curr_data_vec[*no_J];
for(int level=0; level<*no_J; level++){
        curr_data_vec[level]=datamat[level][iter];
               }

//Store the old forward probs from the previous time steps
	for(int i=0; i<nr; i++){
	old_init_vec[i] = init_vec[i];
	}

//Emission density vector computation

	for(int j=0; j<nr; j++){
	
double emiss_den =1; //Emission density variable, this will hold the necessary info

//Extract the corresponding Sigma matrix which is specific to this state
double Sigma_mat_vec[*no_J * *no_J];
for(int entry=0; entry<(*no_J**no_J); entry++){
        Sigma_mat_vec[entry]= *(Sigma_vec+(*no_J**no_J)*j+entry);
      }
//printf("Sigma_mat_vec: %f %f \n", (float) Sigma_mat_vec[0], (float) Sigma_mat_vec[1]);

//printf("Sigma_mat R1 %f %f \n:",  (float) Sigma_mat[0][0], (float) Sigma_mat[0][1]);
//printf("Sigma_mat R2 %f %f \n:",  (float) Sigma_mat[1][0], (float) Sigma_mat[1][1]);


MVN_Sq_density(curr_data_vec, Sigma_mat_vec, no_J, Alt_Sign_mat_vec, &no_sign_combns, &emiss_den);
	
	double update=0; //the previous forward and tp matrix calculation. Needs to be reset to 0 at each iteration
for(int i=0; i <nr; i++){
update += (*(old_init_vec+i) * TPmat[i][j]); //The new unnormalised forward probability for state j
	//\sum \alpha_i * p_{i,j} 
}

*(init_vec+j) = emiss_den * update ; //The unnormalised version of the forward probabilities
	}

for(int i=0; i<nr; i++){
scaling[iter] += *(init_vec+i); // Normalising constant
}

//printf("Scaling: %f \n", (float) scaling[iter]);

for(int i =0; i<nr; i++){
*(init_vec+i) = *(init_vec+i)/scaling[iter]; //Normalised version of the forward probabilities for computational reasons
}


//printf("Normalised Forward Prob: %f %f \n", (float) init_vec[0], (float) init_vec[1]);
*lilo += (float) log(scaling[iter]); //To compute the log-likelihood
}
}
/////////////////////////////////////////////
void MVN_density(double *datavec,double *Sigma_mat_vec, int *Jstar, double *MVN_density){
//C function to compute the density of MVN data
//Assume for the moment that we have a zero mean vector

//datavec=the data from the MVN distribution that we are interested in
//Sigma_mat_vec= the specified covariance-varaicne matrix in vector form
//Jstar= the number of dimensions the datavec is i.e. the dim of the MVN we are interested in
//MVN_density= output, the MVN density of the data vector of interest

//printf("Your in MVN_density \n");
//printf("Data vec : %f %f \n", (float) *(datavec), (float) *(datavec+1) );
//printf("Sigma Mat Vec : %f %f \n", (float) *(Sigma_mat_vec), (float) *(Sigma_mat_vec+1) );
//printf("JStar : %d \n", *Jstar );
//printf("MVN density: %f \n", (float) *MVN_density);

int size = *Jstar;
//Create Sigma_mat, the covariance variance matrix first
double Sigma_mat[size][size];
for(int proc_i=0; proc_i<size; proc_i++){
for(int proc_j=0; proc_j<size; proc_j++){
	Sigma_mat[proc_i][proc_j]= *(Sigma_mat_vec+(size*proc_i)+proc_j) ;//Construct Sigmat mat
}
}

//For the Cholesky decomposition
int pivotArray[size * size]; //since our matrix has (*no_J * *no_J) rows
int errorHandler; //As part of the error Handling process

F77_NAME(dgetrf)(&size,&size,*Sigma_mat,&size,pivotArray,&errorHandler); // The LU decomposition
	//Returns a upper\lower triangular matrix from which we can compute the determinant and inverse more easily

//We can now compute the determinant part
double det=1;
	for(int diag_ent=0;diag_ent<(size);diag_ent++){
		det*= Sigma_mat[diag_ent][diag_ent];
//		printf(", %f",*(sig+i*(size)+i));
	}
	if(det<0){det=-det;}
//printf("Determinant: %f \n", (float) det); 

//Compute the inverse of the 
double lapackWorkspace[size * size];
int dim=size*size;

F77_NAME(dgetri)(&size,*Sigma_mat,&size,pivotArray,lapackWorkspace,&dim,&errorHandler); 
	// does the inverse of the  decomposition

double dsigd=0; //The quadratic exponent part of the density
	for(int proc_i=0;proc_i<size;proc_i++){
		for(int proc_j=0;proc_j<size;proc_j++){
			dsigd+= *(datavec+proc_i)  *  *(datavec+proc_j) *  Sigma_mat[proc_i][proc_j];
		}
	}
//printf("Quadt: %f \n", (float) dsigd); 
		
//So the MVN density is

//printf("Constant: %f \n", (float) 1/R_pow_di(M_2PI, size/2));
//printf("Determinant part: %f \n", (float) 1/sqrt(det));
//printf("Exponential part: %f \n", (float) exp(-0.5* dsigd));
*MVN_density = (1/R_pow_di(M_2PI, size/2)) * (1/sqrt(det)) * (exp(-0.5* dsigd));		
	//For the actual MVN density
}
////////////////////////////////////////////
void MVN_Sq_density(double *datavec,double *Sigma_mat, int *Jstar, int *Alt_Sign_mat_vec, int *Alt_no_combn, double *MVN_Sq_density){
//C function to compute the density of squared MVN data
	//datavec =  the +ve data
	//Sigma_mat_vec =covariance-variance structure in vector form
	//Jstar=the dimension of the MVN of interest
	//Alt_Sign_mat_vec =  the alternating sign matrix which considers all possible combins of sqrt values leading to datavec in vector form
	//Alt_no_combn = number of alternating sign combinations
	//MVN_Sq_density = desired output density of squared MVN data

double sign_sqrt_datavec[*Jstar];
double MVN_part=0; //The MVN part of the density
void MVN_density();


//printf("Your in MVN_SQ_denisty now \n");
//Passing objects across check
//printf("Data vec : %f %f \n", (float) *(datavec), (float) *(datavec+1) );
//printf("Sigma Mat Vec : %f %f \n", (float) *(Sigma_mat), (float) *(Sigma_mat+1) );
//printf("JStar : %d \n", *Jstar );
//printf("Alt Sign Vec : %f %f \n", (float) *Alt_Sign_mat_vec, (float) *(Alt_Sign_mat_vec+1) );
//printf("Alt No  : %d \n", *Alt_no_combn );
//printf("MVN Sq density: %f \n", (float) *MVN_Sq_density);

int Alt_Sign_mat[*Alt_no_combn][*Jstar];
for(int i=0; i<*Alt_no_combn; i++){
for(int j=0; j<*Jstar; j++){
//printf("Alt address: %d \n", *(Alt_Sign_mat_vec+(*Jstar*i)+j));
        Alt_Sign_mat[i][j] = *(Alt_Sign_mat_vec+(*Jstar*i)+j);
		
      }
}
//printf("Alt Sign: %d \n", Alt_Sign_mat[0][0]);

for(int sign_combn=0; sign_combn<*Alt_no_combn; sign_combn++){
for(int proc_i=0; proc_i<*Jstar; proc_i++){
	sign_sqrt_datavec[proc_i]=sqrt(*(datavec+proc_i)) * Alt_Sign_mat[sign_combn][proc_i];
	//The square rooted version of the data with the corresponding sign combination
}
//printf("Sign_Sqrt: %f \n", (float) sign_sqrt_datavec[0]);
double MVN_density_part=0;
MVN_density(sign_sqrt_datavec, Sigma_mat,  Jstar,  &MVN_density_part);
MVN_part += MVN_density_part;
}

//Product of the sqrt of the data
double prod_data=1;
for(int level=0; level<*Jstar; level++){
        prod_data *=sqrt(*(datavec+level)); 
       }

*MVN_Sq_density = MVN_part /(*Alt_no_combn * prod_data);
}
/////////////////////////////////////////////
void Dep_WavPer_Back(double *data_vec, int *ndata, double *TPvec, double *Sigma_vec, double *init_vec, double *scaling_beta, int *Xsize, int *no_J, int *alt_sign_vec, double *beta_vec){

//C versionn of the Backwards equation for Multivariate Wavelet Periodogram processes
//Objects that I need to help me
int iter; //Iterations used in the for loop
//double scaling[*ndata];  // Scaling vector storage 

int nr=*Xsize; //Size of the underlying statespace, the same as Xsize. Just so I don't get confused...
 
double old_init_vec[nr]; //Storage for old 

//Data matrix construction
double datamat[*no_J][*ndata];
for(int level=0; level<*no_J; level++){
for(int time=0; time<*ndata; time++){
        datamat[level][time] =  data_vec[(level*(*ndata))+time];
        }
        }

//TP mat construction
double TPmat[nr][nr]; 	
for(int i=0; i<nr; i++){ //To create a matrix given a vector of the elements
for(int j=0; j<nr; j++){
	TPmat[i][j] = TPvec[(nr*i)+j];
}
}

int no_sign_combns = R_pow_di(2, *no_J);
//printf("No Alt Signs Combins: %i \n", no_sign_combns);

//Alt Sign matrix construction
int Alt_Sign_mat_vec[no_sign_combns * *no_J];
for(int entry=0; entry<(no_sign_combns**no_J); entry++){

Alt_Sign_mat_vec[entry] = *(alt_sign_vec+entry); //Copy of the Alt_Sign Vector
		//printf("Alt Sign: %d \n", Alt_Sign_mat_vec[entry]);
      }

printf("Beta matrix part \n");
//Beta matrix
double betamat[*ndata+1][nr];

for(int state=0; state<nr; state++){
	betamat[*ndata][state] = 1 ;//The set up for the beta matrix
//printf("State %d \n:", state);
	}
//printf("Data T %d \n:", *ndata);


void MVN_Sq_density(); ///The emission density function
double prev_betavec[nr];
for(int iter=*ndata-1; iter>-1; iter--){

//The data that needs to be analysed
double curr_data_vec[*no_J];
for(int level=0; level<*no_J; level++){
        curr_data_vec[level]=datamat[level][(iter+1)-1]; //-1 due to the crazy indexing involved
               }
			   
//Obtain the beta vec that we need to compute first
for(int entry=0; entry<nr; entry++){
	prev_betavec[entry]=betamat[(iter+1+1)-1][entry];
}
printf("After Prev Beta vec \n");

//Emission density
double emiss_den=0;
double emiss_vec[nr];
for(int state_j=0; state_j<nr; state_j++){
double Sigma_mat_vec[*no_J * *no_J];
for(int entry=0; entry<(*no_J**no_J); entry++){
        Sigma_mat_vec[entry]= *(Sigma_vec+(*no_J**no_J)*state_j+entry);
      }
	MVN_Sq_density(curr_data_vec, Sigma_mat_vec, no_J, Alt_Sign_mat_vec, &no_sign_combns, &emiss_den);
emiss_vec[state_j]=emiss_den;
}

//The actual equation...this might be wrong I think
double curr_betavec[nr];
for(int state_i=0; state_i<nr; state_i++){
	for(int state_j; state_j<nr; state_j++){
	curr_betavec[state_i] += TPmat[state_i][state_j] * prev_betavec[state_j] * emiss_vec[state_j];
}
}

//NC bit
double scale_const=0;
for(int entry=0; entry<nr; entry++){
	scale_const += curr_betavec[entry];
}
scaling_beta[iter] =scale_const;

//Normalised  version of the beta probabilities
for(int entry=0; entry<nr; entry++){
	betamat[iter][entry] = curr_betavec[entry]/scale_const;
}
}

//Transform beta matrix to vector
int vec_entry=0;
for(int iter=0; iter<*ndata; iter++){
	for(int entry=0; entry<nr; entry++){
beta_vec[vec_entry] = betamat[iter][entry];
vec_entry += 1;
}
}
}

/////////////////////////////////////////////

void Dep_MVN_Sq_LL(double *data_vec, int *ndata, double *TPvec, double *Scale_vec, double *bSigma_vec, double *init_vec, double *lilo, double *scaling, int *Xsize, int *no_J, double *alt_sign_vec){
//To compute the log-likelihood of a Dependent Multivariate Scaled
	//data= the data matrix in vector form
	//ndata =length of the time points in the data
	//TPvev =transition probability matrix in vector form
	//Scale_vec= Scaling matrix in vector form
	//bSigma_vec= The basic covariance structure which is state invariant
	//init_vec = the initisation vector of the underlying MC
	//lilo = log-likelihood that we want as the output
	//scaling = vector containing scaling constants from which the log-lik is computed from
	//Xsize= The size of the underlying state space
 //no_J = number of scale processes under consideration 

//Objects that I need to help me
int iter; //Iterations used in the for loop
//double scaling[*ndata];  // Scaling vector storage 

int nr=*Xsize; //Size of the underlying statespace, the same as Xsize. Just so I don't get confused...
 
double old_init_vec[nr]; //Storage for old 
	

//Data matrix construction
double datamat[*no_J][*ndata];
for(int level=0; level<*no_J; level++){
for(int time=0; time<*ndata; time++){
        datamat[level][time] =  data_vec[(level*(*ndata))+time];
        }
        }

//TP mat construction
double TPmat[nr][nr]; 	
for(int i=0; i<nr; i++){ //To create a matrix given a vector of the elements
for(int j=0; j<nr; j++){
	TPmat[i][j] = TPvec[(nr*i)+j];
}
}

//Scaling mat construction, digonal for the Cholesky decomposition technically
double Scale_mat[nr][*no_J];
for(int i=0; i<nr; i++){ //Row=state
for(int j=0; j<*no_J; j++){ //Column=Process
        Scale_mat[i][j] = *(Scale_vec+(*no_J*i)+j);
      }
}

//Base Sigma D construction
double bSigma_mat[*no_J][*no_J];
for(int i=0; i<*no_J; i++){
for(int j=0; j<*no_J; j++){
        bSigma_mat[i][j] = *(bSigma_vec+(*no_J*i)+j);
      }
}
//printf("B Sigma Mat R1 %f %f \n:",  (float) bSigma_mat[0][0], (float) bSigma_mat[0][1]);
//printf("B Sigma Mat R2 %f %f \n:",  (float) bSigma_mat[1][0], (float) bSigma_mat[1][1]);
int no_sign_combns = R_pow_di(2, *no_J);
//printf("No Alt Signs Combins: %i \n", no_sign_combns);

//Alt Sign matrix construction
int Alt_Sign_mat[no_sign_combns][*no_J];
for(int i=0; i<(no_sign_combns); i++){
for(int j=0; j<*no_J; j++){
        Alt_Sign_mat[i][j] = *(alt_sign_vec+(*no_J*i)+j);
		//printf("Alt Sign: %d \n", Alt_Sign_mat[i][j]);
      }
}

//Some information regarding the computation of the MVN emission density
int pivotArray[*no_J * *no_J]; //since our matrix has (*no_J * *no_J) rows
int errorHandler; //As part of the error Handling process
double lapackWorkspace[*no_J * *no_J];
int size=*no_J;
double det; //For the determintant matrix later on
int dim=size*size;
double	dsigd=0;
double MVNdensity;
double MVNpart=0;
//The actual forward equations recursion
for(iter=0; iter<*ndata; iter++) {

//Current data at the time point
double curr_data_vec[*no_J];
double prod_data=1;
for(int level=0; level<*no_J; level++){
        curr_data_vec[level]=sqrt(datamat[level][iter]);
        prod_data *=sqrt(datamat[level][iter]); //CV part
       }

//Store the old forward probs from the previous time steps
	for(int i=0; i<nr; i++){
	old_init_vec[i] = init_vec[i];
	}

//Emission density vector computation
	for(int j=0; j<nr; j++){
	
double emiss_den =1; //Emission density variable
double MVNpart=0;

//Sigma D construction (since C likes to overwrite)
double Sigma_mat[*no_J][*no_J];
for(int enti=0; enti<*no_J; enti++){
for(int entj=0; entj<*no_J; entj++){
        Sigma_mat[enti][entj] = bSigma_mat[enti][entj];
      }
}

for(int diag_ent=0; diag_ent<size; diag_ent++){
Sigma_mat[diag_ent][diag_ent]=Scale_mat[j][diag_ent]; //Construct the corresponding SigmaD matrix associated with this state by replacing the diagonal
}

//printf("Sigma_mat R1 %f %f \n:",  (float) Sigma_mat[0][0], (float) Sigma_mat[0][1]);
//printf("Sigma_mat R2 %f %f \n:",  (float) Sigma_mat[1][0], (float) Sigma_mat[1][1]);

//Compute the MVN stuff first
F77_NAME(dgetrf)(&size,&size,*Sigma_mat,&size,pivotArray,&errorHandler); // The LU decomposition

//We can now compute the determinant part
det=1;
	for(int diag_ent=0;diag_ent<(size);diag_ent++){
		det*= Sigma_mat[diag_ent][diag_ent];
//		printf(", %f",*(sig+i*(size)+i));
	}
	if(det<0){det=-det;}
//printf("Determinant: %f \n", (float) det); 
//Compute the inverse of the 
F77_NAME(dgetri)(&size,*Sigma_mat,&size,pivotArray,lapackWorkspace,&dim,&errorHandler); // does inverse on decomposition

for(int sign_combn=0; sign_combn<(no_sign_combns); sign_combn++){
//Compute the quadratic part
	dsigd=0;
	for(int proc_i=0;proc_i<(size);proc_i++){
		for(int proc_j=0;proc_j<(size);proc_j++){
			dsigd+= (*(curr_data_vec+proc_i) *Alt_Sign_mat[sign_combn][proc_i] ) *  (*(curr_data_vec+proc_j)*Alt_Sign_mat[sign_combn][proc_j]   )*  Sigma_mat[proc_i][proc_j];
		}
	}
//printf("Quadt: %f \n", (float) dsigd); 
	
//So the MVN density is

//printf("Constant: %f \n", (float) 1/R_pow_di(M_2PI, size/2));
//printf("Determinant part: %f \n", (float) 1/sqrt(det));
//printf("Exponential part: %f \n", (float) exp(-0.5* dsigd));
MVNdensity = (1/R_pow_di(M_2PI, size/2)) * (1/sqrt(det)) * (exp(-0.5* dsigd));		
//printf("MVN Density %f \n:", (float) MVNdensity);
MVNpart += MVNdensity;
}

emiss_den = MVNpart /(no_sign_combns * prod_data);

	double update=0; //the previous forward and tp matrix calculation. Needs to be reset to 0 at each iteration
for(int i=0; i <nr; i++){
update += (*(old_init_vec+i) * TPmat[i][j]); //The new unnormalised forward probability for state j
	//\sum \alpha_i * p_{i,j} 
}

*(init_vec+j) = emiss_den * update ; //The unnormalised version of the forward probabilities
	}

for(int i=0; i<nr; i++){
scaling[iter] += *(init_vec+i); // Normalising constant
}

//printf("Scaling: %f \n", (float) scaling[iter]);

for(int i =0; i<nr; i++){
*(init_vec+i) = *(init_vec+i)/scaling[iter]; //Normalised version of the forward probabilities for computational reasons
}

//printf("Normalised Forward Prob: %f %f \n", (float) init_vec[0], (float) init_vec[1]);
*lilo += (float) log(scaling[iter]); //To compute the log-likelihood
}
}

/////////////////////////////////////////

void Dep_MVN_LL(double *data_vec, int *ndata, double *TPvec, double *Scale_vec, double *bSigma_vec, double *init_vec, double *lilo, double *scaling, int *Xsize, int *no_J){
//To compute the log-likelihood of a Dependent Multivariate Normal Processes
	//data= the data matrix in vector form
	//ndata =length of the time points in the data
	//TPvev =transition probability matrix in vector form
	//Scale_vec= Scaling matrix in vector form
	//bSigma_vec= The basic covariance structure which is state invariant
	//init_vec = the initisation vector of the underlying MC
	//lilo = log-likelihood that we want as the output
	//scaling = vector containing scaling constants from which the log-lik is computed from
	//Xsize= The size of the underlying state space
 //no_J = number of scale processes under consideration 

//Objects that I need to help me
int iter; //Iterations used in the for loop
//double scaling[*ndata];  // Scaling vector storage 

int nr=*Xsize; //Size of the underlying statespace, the same as Xsize. Just so I don't get confused...
 
double old_init_vec[nr]; //Storage for old 
	

//Data matrix construction
double datamat[*no_J][*ndata];
for(int level=0; level<*no_J; level++){
for(int time=0; time<*ndata; time++){
        datamat[level][time] =  data_vec[(level*(*ndata))+time];
        }
        }

//TP mat construction
double TPmat[nr][nr]; 	
for(int i=0; i<nr; i++){ //To create a matrix given a vector of the elements
for(int j=0; j<nr; j++){
	TPmat[i][j] = TPvec[(nr*i)+j];
}
}

//Scaling mat construction, digonal for the Cholesky decomposition technically
double Scale_mat[nr][*no_J];
for(int i=0; i<nr; i++){ //Row=state
for(int j=0; j<*no_J; j++){ //Column=Process
        Scale_mat[i][j] = *(Scale_vec+(*no_J*i)+j);
      }
}

//Base Sigma D construction
double bSigma_mat[*no_J][*no_J];
for(int i=0; i<*no_J; i++){
for(int j=0; j<*no_J; j++){
        bSigma_mat[i][j] = *(bSigma_vec+(*no_J*i)+j);
      }
}
//printf("B Sigma Mat R1 %f %f \n:",  (float) bSigma_mat[0][0], (float) bSigma_mat[0][1]);
//printf("B Sigma Mat R2 %f %f \n:",  (float) bSigma_mat[1][0], (float) bSigma_mat[1][1]);

//Some information regarding the computation of the MVN emission density
int pivotArray[*no_J * *no_J]; //since our matrix has (*no_J * *no_J) rows
int errorHandler; //As part of the error Handling process
double lapackWorkspace[*no_J * *no_J];
int size=*no_J;
double det; //For the determintant matrix later on
int dim=size*size;
double	dsigd=0;
double MVNdensity;

//The actual forward equations recursion
for(iter=0; iter<*ndata; iter++) {

//Current data at the time point
double curr_data_vec[*no_J];
double prod_data=1;
for(int level=0; level<*no_J; level++){
        curr_data_vec[level]=datamat[level][iter];
        //prod_data *=sqrt(datamat[level][iter]); //CV part
       }

//Store the old forward probs from the previous time steps
	for(int i=0; i<nr; i++){
	old_init_vec[i] = init_vec[i];
	}

//Emission density vector computation
	for(int j=0; j<nr; j++){
	
double emiss_den =1; //Emission density variable

//Sigma D construction (since C likes to overwrite)
double Sigma_mat[*no_J][*no_J];
for(int enti=0; enti<*no_J; enti++){
for(int entj=0; entj<*no_J; entj++){
        Sigma_mat[enti][entj] = bSigma_mat[enti][entj];
      }
}

for(int diag_ent=0; diag_ent<size; diag_ent++){
Sigma_mat[diag_ent][diag_ent]=Scale_mat[j][diag_ent]; //Construct the corresponding SigmaD matrix associated with this state by replacing the diagonal
}

//printf("Sigma_mat R1 %f %f \n:",  (float) Sigma_mat[0][0], (float) Sigma_mat[0][1]);
//printf("Sigma_mat R2 %f %f \n:",  (float) Sigma_mat[1][0], (float) Sigma_mat[1][1]);

//Compute the MVN stuff first
F77_NAME(dgetrf)(&size,&size,*Sigma_mat,&size,pivotArray,&errorHandler); // The LU decomposition

//We can now compute the determinant part
det=1;
	for(int diag_ent=0;diag_ent<(size);diag_ent++){
		det*= Sigma_mat[diag_ent][diag_ent];
//		printf(", %f",*(sig+i*(size)+i));
	}
	if(det<0){det=-det;}
//printf("Determinant: %f \n", (float) det); 
//Compute the inverse of the 
F77_NAME(dgetri)(&size,*Sigma_mat,&size,pivotArray,lapackWorkspace,&dim,&errorHandler); // does inverse on decomposition

//Compute the quadratic part
	dsigd=0;
	for(int proc_i=0;proc_i<(size);proc_i++){
		for(int proc_j=0;proc_j<(size);proc_j++){
			dsigd+= *(curr_data_vec+proc_i)  *  *(curr_data_vec+proc_j)  *  Sigma_mat[proc_i][proc_j];
		}
	}
//printf("Quadt: %f \n", (float) dsigd); 
	
//So the MVN density is

//printf("Constant: %f \n", (float) 1/R_pow_di(M_2PI, size/2));
//printf("Determinant part: %f \n", (float) 1/sqrt(det));
//printf("Exponential part: %f \n", (float) exp(-0.5* dsigd));
MVNdensity = (1/R_pow_di(M_2PI, size/2)) * (1/sqrt(det)) * (exp(-0.5* dsigd));		
//printf("MVN Density %f \n:", (float) MVNdensity);

emiss_den = MVNdensity / prod_data;

	double update=0; //the previous forward and tp matrix calculation. Needs to be reset to 0 at each iteration
for(int i=0; i <nr; i++){
update += (*(old_init_vec+i) * TPmat[i][j]); //The new unnormalised forward probability for state j
	//\sum \alpha_i * p_{i,j} 
}

*(init_vec+j) = emiss_den * update ; //The unnormalised version of the forward probabilities
	}

for(int i=0; i<nr; i++){
scaling[iter] += *(init_vec+i); // Normalising constant
}

//printf("Scaling: %f \n", (float) scaling[iter]);

for(int i =0; i<nr; i++){
*(init_vec+i) = *(init_vec+i)/scaling[iter]; //Normalised version of the forward probabilities for computational reasons
}

//printf("Normalised Forward Prob: %f %f \n", (float) init_vec[0], (float) init_vec[1]);
*lilo += (float) log(scaling[iter]); //To compute the log-likelihood
}
}

/////////////////////


