#File containing supplementary, auxiliary function when computing the statespace for FMCI.

#########
FINAL.FMCI_SS.conversion<-function(Z.rtuples, rval){
#Function to convert the states in the augmented statespace for the auxiliary MCs, Z, e.g. 1,2,3,1| 4
#into matrix form with the last column denoting the associated pattern progress

no.Z<-length(Z.rtuples)
part.a<-matrix(unlist(strsplit(Z.rtuples, "\\|")), ncol=2, nrow=no.Z, byrow=T) #Matrix with r-tuples in column 1, pattern progress in column 2
part.b<-matrix(unlist(strsplit(part.a[,1], "\\,")), nrow=no.Z, ncol=rval, byrow=T) #rtuples in matrix form

Z.rtuples.mat<-cbind(part.b, part.a[,2])
list("States Matrix"=Z.rtuples.mat, "r-tuples"=part.a[,1])
}

##########
FINAL.FMCI_SS.conversion2<-function(Z.rtuples.mat){
#Function to convert the matrix form of the states of the auxiliary MCs, Z, with the final column denoting the pattern progress
#into statespace vector where each row of the matrix is one element of the vector.

rval<-ncol(Z.rtuples.mat)-1
rtuples<-apply(Z.rtuples.mat[,1:rval, drop=F], 1, FUN=paste, collapse=",") #The corresponding r-tuples
Z.rtuples<-paste(rtuples, Z.rtuples.mat[,rval+1, drop=F], sep="|")

list("States Vector"=Z.rtuples, "r-tuples"=rtuples)
}

